SystemOrganization addCategory: #'Fuel-Tests'!
SystemOrganization addCategory: #'Fuel-Core'!
SystemOrganization addCategory: #'Fuel-Core-Cluster'!
SystemOrganization addCategory: #'Fuel-Core-Analyzer'!
SystemOrganization addCategory: #'Fuel-Core-Errors'!
SystemOrganization addCategory: #'Fuel-Collections'!

Trait named: #FLTClassParameter
	uses: {}
	category: 'Fuel-Core-Cluster'!

!FLTClassParameter classSide methodsFor: 'instance creation' stamp: 'MartinDias 4/19/2011 12:36'!
for: aClass

	^ self basicNew
		parameterClass: aClass;
		yourself.! !

!FLTClassParameter methodsFor: 'comparing' stamp: 'MartinDias 4/19/2011 12:36'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ self parameterClass = anObject parameterClass! !

!FLTClassParameter methodsFor: 'comparing' stamp: 'MartinDias 4/19/2011 12:36'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ self parameterClass hash! !

!FLTClassParameter methodsFor: 'accessing' stamp: 'MartinDias 4/19/2011 12:35'!
parameterClass

	self explicitRequirement ! !

!FLTClassParameter methodsFor: 'accessing' stamp: 'MartinDias 4/19/2011 12:35'!
parameterClass: aClass

	self explicitRequirement ! !

!FLTClassParameter methodsFor: 'printing' stamp: 'MartinDias 4/19/2011 12:36'!
printOn: aStream
	"Append to the argument, aStream, a sequence of characters that  
	identifies the receiver."
	
	super printOn: aStream.
	aStream nextPut: $(.
	self parameterClass printOn: aStream.
	aStream nextPut: $).
	! !

!ByteString methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 15:11'!
fuelAccept: aVisitor

	aVisitor visitPrimitive: self! !

!ByteString methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 13:39'!
fuelSerializer

	^ FLByteStringClusterSerializer instance! !

!ByteSymbol methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 15:12'!
fuelAccept: aVisitor

	aVisitor visitPrimitive: self! !

!ByteSymbol methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 15:13'!
fuelSerializer

	^ FLSymbolClusterSerializer instance! !

!OrderedCollection methodsFor: '*Fuel' stamp: 'MartinDias 10/12/2010 16:11'!
hasAnyDuplicate
	"Answers if there is an element added more than one time"

	^ self size ~= self asSet size ! !

!SmallInteger methodsFor: '*Fuel' stamp: 'MartinDias 12/28/2010 14:12'!
fuelSerializer

	^ FLSmallIntegerClusterSerializer for: self! !

Stream subclass: #FLBufferedWriteStream
	instanceVariableNames: 'stream buffer position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core'!

!FLBufferedWriteStream class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
on: writeStream
	^ self basicNew
		on: writeStream;
		yourself! !

!FLBufferedWriteStream class methodsFor: 'convenience' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
on: writeStream do: block
	"Execute block with as argument a ZnBufferedWriteStream on writeStream,
	making sure #flush is called at the end."
	
	| bufferedWriteStream |
	bufferedWriteStream := self on: writeStream.
	block value: bufferedWriteStream.
	bufferedWriteStream flush! !

!FLBufferedWriteStream methodsFor: 'private' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
buffer
	buffer isNil 
		ifTrue: [ self sizeBuffer: self defaultBufferSize ].
	^ buffer! !

!FLBufferedWriteStream methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
bufferFreeSize
	^ self bufferSize - position! !

!FLBufferedWriteStream methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
bufferSize
	^ buffer isNil 
		ifTrue: [ self defaultBufferSize ]
		ifFalse: [ buffer size ]! !

!FLBufferedWriteStream methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
close
	self flushBuffer.
	stream close! !

!FLBufferedWriteStream methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
defaultBufferSize
	^ 8192 "2 raisedTo: 13  "
	

! !

!FLBufferedWriteStream methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
flush
	self flushBuffer.
	stream flush! !

!FLBufferedWriteStream methodsFor: 'private' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
flushBuffer
	position = 0 ifTrue: [ ^ self ].
	position = self bufferSize
		ifTrue: [
			stream nextPutAll: buffer ]
		ifFalse: [
			(stream respondsTo: #next:putAll:startingAt:)
				ifTrue: [ stream next: position putAll: buffer startingAt: 1 ]
				ifFalse: [ stream nextPutAll: (buffer copyFrom: 1 to: position) ] ].
	position := 0! !

!FLBufferedWriteStream methodsFor: 'private' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
flushBufferIfFull
	position = self bufferSize 
		ifTrue: [ self flushBuffer ]
! !

!FLBufferedWriteStream methodsFor: 'printing' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
nextInt32Put: int32
	"Write a signed integer to the next 4 bytes"
	| pos |
	self flushBufferIfFull.
	pos := int32 < 0
		ifTrue: [(0-int32) bitInvert32 + 1]
		ifFalse: [int32].
	1 to: 4 do: [:i | self nextPut: (pos digitAt: 5-i)].
	^ int32! !

!FLBufferedWriteStream methodsFor: 'writing' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
nextNumber: n put: v 
	"Append to the receiver the argument, v, which is a positive 
	SmallInteger or a LargePositiveInteger, as the next n bytes.
	Possibly pad with leading zeros."
	self flushBufferIfFull.
	1 to: n do: [:i | self nextPut: (v digitAt: n+1-i)].
	^ v
! !

!FLBufferedWriteStream methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
nextPut: object
	self flushBufferIfFull.
	position := position + 1.
	self buffer at: position put: object! !

!FLBufferedWriteStream methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
nextPutAll: collection
	self flushBufferIfFull.
	collection size <= self bufferFreeSize
		ifTrue: [
			self buffer replaceFrom: position + 1 to: position + collection size with: collection.
			position := position + collection size ]
		ifFalse: [
			self flushBuffer.
			collection size > (self bufferSize / 2)
				ifTrue: [ stream nextPutAll: collection ]
				ifFalse: [ self nextPutAll: collection ] ]
! !

!FLBufferedWriteStream methodsFor: 'writing' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
nextStringPut: s 
	"Append the string, s, to the receiver.  Only used by DataStream.  Max size of 64*256*256*256."

	| length |
	self flushBufferIfFull.
	(length := s size) < 192
		ifTrue: [self nextPut: length]
		ifFalse: 
			[self nextPut: (length digitAt: 4)+192.
			self nextPut: (length digitAt: 3).
			self nextPut: (length digitAt: 2).
			self nextPut: (length digitAt: 1)].
	self nextPutAll: s asByteArray.
	^s! !

!FLBufferedWriteStream methodsFor: 'writing' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
nextWordPut: aWord 
	"Append to the receiver an Integer as the next two bytes."
	self flushBufferIfFull.
	self nextPut: ((aWord bitShift: -8) bitAnd: 255).
	self nextPut: (aWord bitAnd: 255).
	^aWord! !

!FLBufferedWriteStream methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
on: writeStream
	stream := writeStream.
	position := 0! !

!FLBufferedWriteStream methodsFor: 'printing' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
printOn: aStream
	aStream 
		nextPutAll: 'a '; 
		nextPutAll: self class name! !

!FLBufferedWriteStream methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
sizeBuffer: size
	buffer := (stream isBinary ifTrue: [ ByteArray ] ifFalse: [ String ]) new: size! !

!FLBufferedWriteStream methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
space
	self nextPut: Character space! !

!Trait methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 15:23'!
fuelAccept: aVisitor

	aVisitor visitClassOrTrait: self! !

!Trait methodsFor: '*Fuel' stamp: 'MartinDias 3/24/2011 03:34'!
fuelSerializer 

	^FLTraitClusterSerializer instance! !

!CompiledMethod methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 15:33'!
fuelAccept: aVisitor

	aVisitor visitObject: self.! !

!CompiledMethod methodsFor: '*Fuel' stamp: 'MartinDias 10/22/2010 12:56'!
fuelSerializer 

	^ (self isNamedPrimitive)
		ifTrue:  [ FLNamedPrimitiveMethodClusterSerializer instance ]
		ifFalse: [ FLCompiledMethodClusterSerializer instance ]
! !

!CompiledMethod methodsFor: '*Fuel' stamp: 'MartinDias 10/22/2010 12:56'!
isNamedPrimitive 

	^ self primitive = 117! !

!Behavior methodsFor: '*Fuel' stamp: 'MartinDias 10/12/2010 10:54'!
hasInstanceVariables
	"Returns whether the receiver has instance variables"
	
	^ self instSize > 0 ! !

!Behavior methodsFor: '*Fuel' stamp: 'MartinDias 3/28/2011 02:39'!
initializeTraitComposition: aTraitComposition

	aTraitComposition assertValidUser: self.
	self traitComposition: aTraitComposition.
	aTraitComposition traits do: [:each | each addUser: self]! !

!Behavior methodsFor: '*Fuel' stamp: 'MartinDias 3/17/2011 16:36'!
printCompactHierarchy
	"Returns a short description of the class hierarchy"
	
	^ self withAllSuperclasses inject: '' into: [:a :b | b printString, '.', a ]! !

!ClassTrait methodsFor: '*Fuel' stamp: 'MartinDias 3/23/2011 18:10'!
fuelSerializer 
	^ FLClassSideClusterSerializer instance.! !

!MethodDictionary methodsFor: '*Fuel' stamp: 'MartinDias 3/22/2011 02:13'!
fuelSerializer 

	^ FLMethodDictionaryClusterSerializer instance! !

Error subclass: #ClassNotFound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Errors'!

!UndefinedObject methodsFor: '*Fuel' stamp: 'MartinDias 10/19/2010 10:50'!
fuelAccept: aVisitor

	aVisitor visitNilTrueFalse: self.! !

!UndefinedObject methodsFor: '*Fuel' stamp: 'TristanBourgois 9/24/2010 13:56'!
fuelSerializer 

	^ FLNilTrueFalseClusterSerializer instance! !

!Float methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 15:27'!
fuelAccept: aVisitor

	aVisitor visitPrimitive: self! !

!Float methodsFor: '*Fuel' stamp: 'MartinDias 10/20/2010 22:46'!
fuelSerializer 

	^ FLFloatClusterSerializer instance! !

!Integer methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 15:26'!
fuelAccept: aVisitor

	aVisitor visitPrimitive: self! !

!LargePositiveInteger methodsFor: '*Fuel' stamp: 'TristanBourgois 9/24/2010 14:21'!
fuelSerializer 

	^ FLLargePositiveIntegerClusterSerializer instance.! !

!Character methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 15:28'!
fuelAccept: aVisitor

	aVisitor visitPrimitive: self! !

!Character methodsFor: '*Fuel' stamp: 'MartinDias 9/23/2010 17:41'!
fuelSerializer

	^ FLCharacterClusterSerializer instance! !

!ArrayedCollection methodsFor: '*Fuel' stamp: 'MarianoMartinezPeck 5/13/2011 10:16'!
fuelSerializer

	^ (self class isPointers not and: [self class isWords])
		ifTrue: [(FLRawArrayedCollectionClusterSerializer for: self class)]
		ifFalse: [super fuelSerializer].! !

!Boolean methodsFor: '*Fuel' stamp: 'MartinDias 10/19/2010 10:50'!
fuelAccept: aVisitor

	aVisitor visitNilTrueFalse: self.! !

!Boolean methodsFor: '*Fuel' stamp: 'MartinDias 9/27/2010 09:15'!
fuelSerializer 

	^ FLNilTrueFalseClusterSerializer instance ! !

!Class methodsFor: '*Fuel' stamp: 'MartinDias 5/14/2011 21:44'!
basicSubclasses

	^ subclasses! !

!Class methodsFor: '*Fuel' stamp: 'MartinDias 5/14/2011 21:45'!
basicSubclasses: anArray

	subclasses := anArray! !

!Class methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 15:23'!
fuelAccept: aVisitor

	aVisitor visitClassOrTrait: self! !

!Class methodsFor: '*Fuel' stamp: 'MartinDias 3/2/2011 23:31'!
fuelSerializer 

	^ FLClassClusterSerializer instance ! !

!Metaclass methodsFor: '*Fuel' stamp: 'MartinDias 10/19/2010 10:50'!
fuelAccept: aVisitor

	aVisitor visitMetaclass: self! !

!Metaclass methodsFor: '*Fuel' stamp: 'MartinDias 3/23/2011 18:10'!
fuelSerializer 
	^ FLClassSideClusterSerializer instance.! !

!ByteArray methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 15:06'!
fuelAccept: aVisitor

	aVisitor visitPrimitive: self! !

!ByteArray methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 14:38'!
fuelSerializer 

	^ FLByteArrayClusterSerializer instance! !

!LargeNegativeInteger methodsFor: '*Fuel' stamp: 'TristanBourgois 9/24/2010 15:09'!
fuelSerializer 

	^ FLLargeNegativeIntegerClusterSerializer instance.! !

!TraitBehavior methodsFor: '*Fuel' stamp: 'MartinDias 3/28/2011 02:45'!
initializeTraitComposition: aTraitComposition

	self traitComposition: aTraitComposition.
	aTraitComposition traits do: [:each | each addUser: self]! !

Object subclass: #FLAnalyzer
	instanceVariableNames: 'objectCount analyzers clusteredBaselevelObjects clusteredExternalMetalevelObjects clusteredInternalMetalevelObjects objectStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Analyzer'!

!FLAnalyzer commentStamp: '<historical>' prior: 0!
I am responsible of traverse the graph of references starting on a collection of root objects. I will produce dictionaries that associate each traversed object to a serializer.

An example of use is

	FLAnalyzer newDefault 
		analyzeAll: { 1@2. 3@4 };
		clusteredInstances.
	
The results are used by FLSerializer to serialize the analyzed objects into a stream.!

!FLAnalyzer class methodsFor: 'instance creation' stamp: 'MartinDias 10/26/2010 10:32'!
new

	self error: 'Should use an specific instance creation message.'! !

!FLAnalyzer class methodsFor: 'instance creation' stamp: 'MartinDias 10/26/2010 10:31'!
newDefault

	^ self basicNew 
		initialize; 
		initializeDefaultAnalyzers;
		yourself! !

!FLAnalyzer class methodsFor: 'instance creation' stamp: 'MartinDias 3/26/2011 17:13'!
newDefaultInternalObjects: aCollection
	"Returns an instance with default configuration, declaring an internal the objects in the collection."

	| analyzer globalAnalyzer classPoolAssociationAnalyzer |
	analyzer := self basicNew 
		initialize; 
		yourself.
		
	self flag: #todo. "Reify configuration and remove this crap"
	
	globalAnalyzer := (FLGlobalAnalyzer newWith: analyzer) 
		notExternalObjects: aCollection; 
		yourself.
		
	classPoolAssociationAnalyzer := (FLClassPoolAssociationAnalyzer newWith: analyzer) 
		notExternalObjects: aCollection; 
		yourself.
		
	analyzer analyzers 
		add: (FLGlobalAssociationAnalyzer newWith: analyzer);
		add: classPoolAssociationAnalyzer;
		add: globalAnalyzer;
		add: (FLDefaultAnalyzer newWith: analyzer).
		
	^ analyzer! !

!FLAnalyzer methodsFor: 'analyze' stamp: 'MartinDias 5/15/2011 22:58'!
analyze: anObject

	objectStack push: anObject.

	[ objectStack isEmpty ] 
		whileFalse: [ self doAnalyze: objectStack pop ]
! !

!FLAnalyzer methodsFor: 'protected' stamp: 'MartinDias 10/26/2010 10:35'!
analyzerFor: anObject

	^ analyzers detect: [ :anAnalyzer | anAnalyzer analyzes: anObject ].
! !

!FLAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 3/2/2011 21:05'!
analyzers
	^ analyzers! !

!FLAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 11/3/2010 14:58'!
clusteredBaselevelObjects
	
	^ clusteredBaselevelObjects! !

!FLAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 3/2/2011 23:57'!
clusteredExternalMetalevelObjects
	
	^ clusteredExternalMetalevelObjects ! !

!FLAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 3/2/2011 23:57'!
clusteredInternalMetalevelObjects
	
	^ clusteredInternalMetalevelObjects ! !

!FLAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 3/2/2011 23:59'!
clusteredObjects
	"Returns a new collection with all the clustered objects, in Association instances."
	
	^ (OrderedCollection new: 
			clusteredExternalMetalevelObjects size + 
			clusteredInternalMetalevelObjects size + 
			clusteredBaselevelObjects size) 
		addAll: clusteredExternalMetalevelObjects associations;
		addAll: clusteredInternalMetalevelObjects associations;
		addAll: clusteredBaselevelObjects associations;
		yourself.! !

!FLAnalyzer methodsFor: 'protected' stamp: 'MartinDias 11/11/2010 16:11'!
clusters: aDictionary add: anObject

	self
		clusters: aDictionary
		add: anObject
		serializer: anObject fuelSerializer! !

!FLAnalyzer methodsFor: 'protected' stamp: 'MartinDias 11/11/2010 16:19'!
clusters: aDictionary add: anObject serializer: aSerializer

	self 
		clusters: aDictionary 
		add: anObject 
		serializer: aSerializer 
		collectionFactoryBlock: [ IdentitySet new ]
! !

!FLAnalyzer methodsFor: 'protected' stamp: 'MartinDias 5/15/2011 22:57'!
clusters: aDictionary add: anObject serializer: aSerializer collectionFactoryBlock: aBlockForNewCollection

	| clusterObjects |
	clusterObjects := 
		aDictionary 
			at: aSerializer 
			ifAbsentPut: [ aBlockForNewCollection value ].

	(clusterObjects includes: anObject)
		ifTrue: [ ^ self ].

	clusterObjects add: anObject.
	objectCount := objectCount + 1.
	(clusterObjects size = 1) ifTrue: [ aSerializer clusterReferencesDo: [ :aChild | objectStack push: aChild ] ].
	aSerializer referencesOf: anObject do: [ :aChild | objectStack push: aChild ].! !

!FLAnalyzer methodsFor: 'protected' stamp: 'MartinDias 5/15/2011 17:46'!
doAnalyze: anObject

	(self analyzerFor: anObject) value: anObject ! !

!FLAnalyzer methodsFor: 'initialize-release' stamp: 'MartinDias 5/15/2011 22:56'!
initialize

	objectStack := FLSimpleStack new.
	clusteredBaselevelObjects := Dictionary new.
	clusteredExternalMetalevelObjects := Dictionary new.
	clusteredInternalMetalevelObjects := Dictionary new.
	objectCount := 0.
	analyzers := OrderedCollection new.
! !

!FLAnalyzer methodsFor: 'initialize-release' stamp: 'MartinDias 10/26/2010 10:30'!
initializeDefaultAnalyzers

	analyzers 
		add: (FLGlobalAssociationAnalyzer newWith: self);
		add: (FLClassPoolAssociationAnalyzer newWith: self);
		add: (FLGlobalAnalyzer newWith: self);
		add: (FLDefaultAnalyzer newWith: self)
! !

!FLAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 10/19/2010 10:31'!
objectCount

	^ objectCount! !

Object subclass: #FLClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

FLClusterSerializer class
	instanceVariableNames: 'instance serializersById'!

!FLClusterSerializer commentStamp: '<historical>' prior: 0!
I represent a special way of serializing and materializing some specific kind of objects.

Each of my non-abstract subclasses answers to #id with an unique integer, that identifies it. 

Sending me the #forId: message you obtain an instance that corresponds with an specific id. 

Every object responds to #fuelSerializer with its corresponding subclass of me. For example:

	42 fuelSerializer 
	
will return a serializer for that specific instance of SmallInteger.!

FLClusterSerializer class
	instanceVariableNames: 'instance serializersById'!

!FLClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 15:24'!
allSubclassesWithId
	"Answers a collection with all the subclasses that define an id. In other words, all the non-abstract subclasses are returned"

	^self allSubclasses select: [ :aClass | 
			[ aClass id isInteger ] ifError: [ false ] ] 
	! !

!FLClusterSerializer classSide methodsFor: 'instance creation' stamp: 'MartinDias 10/18/2010 12:34'!
forId: anInteger
	"Returns the serializer instance that corresponds to the id received"

	^ self serializersById 
			at: anInteger 
			ifAbsent: [ self error: 'Could not find a serializer with id=', anInteger asString ].
	
! !

!FLClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:56'!
id
	"Answer an integer identifier. It must be between 0 and 255. 
	Each type of primitive object should have a different one. 
	validateIdDistribution checks that there is no overlap."
	
	self subclassResponsibility ! !

!FLClusterSerializer classSide methodsFor: 'class initialization' stamp: 'MartinDias 5/13/2011 10:20'!
initialize

	self resetHierarchy! !

!FLClusterSerializer classSide methodsFor: 'instance creation' stamp: 'MartinDias 10/15/2010 11:29'!
instance
	"Returns the singleton instance of this class. It may not be sent to abstract classes, see class doc."
	
	^ instance ifNil: [ instance := self basicNew initialize ]
	
! !

!FLClusterSerializer classSide methodsFor: 'class initialization' stamp: 'MartinDias 3/21/2011 17:33'!
reset
	"Resets singleton class variables"

	instance := nil.
	serializersById := nil.! !

!FLClusterSerializer classSide methodsFor: 'class initialization' stamp: 'MartinDias 3/21/2011 17:34'!
resetHierarchy
	"Resets class variables in the whole hierarchy"

	self withAllSubclasses do: [ :x | x reset ]! !

!FLClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 15:16'!
serializersById
	"Returns a dictionary that indexes the serializers by their ids"

	serializersById ifNil: [
			serializersById := IdentityDictionary new.
			self allSubclassesWithId 
				do: [ :aSerializerClass | 
					serializersById 
						at: aSerializerClass id 
						put: aSerializerClass instance ] ].
	^ serializersById 
! !

!FLClusterSerializer classSide methodsFor: 'checking' stamp: 'MartinDias 10/12/2010 16:06'!
validateIdDistribution
	"Verifies that subclasses do not have overlapping ids"
	
	self assert: (self allSubclassesWithId collect: [ :aClass | aClass id ]) hasAnyDuplicate not
		description: 'Overlapping id detected in FLClusterSerializer subclasses'! !

!FLClusterSerializer methodsFor: 'analyzing' stamp: 'MartinDias 4/19/2011 19:53'!
clusterReferencesDo: aBlock
	"Evaluates the received block with each object referenced by the cluster"! !

!FLClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 11:35'!
materializeAllWith: aMaterializer

	self subclassResponsibility ! !

!FLClusterSerializer methodsFor: 'analyzing' stamp: 'MartinDias 3/2/2011 23:07'!
referencesOf: anObject do: aBlock
	"Evaluates the received block with each object referenced by anObject"! !

!FLClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 11:11'!
serializeAll: clusterInstances with: aSerializer

	self subclassResponsibility ! !

FLClusterSerializer subclass: #FLIteratingClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLIteratingClusterSerializer commentStamp: '<historical>' prior: 0!
I am a template class whose algorithm for serialize a collection of objects consists on delegate the serialization of each individual object to the subclass.!

FLIteratingClusterSerializer subclass: #FLClassOrTraitClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLClassOrTraitClusterSerializer commentStamp: '<historical>' prior: 0!
I have the common behavior for serializing a class or a trait with full detail. The class or trait will be recreated completely on the materializing image.!

FLClassOrTraitClusterSerializer subclass: #FLClassClusterSerializer
	instanceVariableNames: ''
	classVariableNames: 'SubclassSelectors'
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLClassClusterSerializer commentStamp: '<historical>' prior: 0!
I serialize a class with full detail. The class will be recreated completely on the materializing image.

TODO: describe different scenarios for materialization:

- when the class already exists in the image:
-- the class' format changes (for example, #isVariable changes its value)
-- the instance variables are different

- when the superclass doesn't exist

- other!

!FLClassClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 3/2/2011 23:09'!
id
	^ 17! !

!FLClassClusterSerializer classSide methodsFor: 'initialize-release' stamp: 'MartinDias 3/29/2011 22:35'!
initialize

	SubclassSelectors := Dictionary new
		at: #normal put: #subclass:instanceVariableNames:classVariableNames:poolDictionaries:category:;
		at: #weak put: #weakSubclass:instanceVariableNames:classVariableNames:poolDictionaries:category:;
		at: #variable put: #variableSubclass:instanceVariableNames:classVariableNames:poolDictionaries:category:;
		at: #bytes put: #variableByteSubclass:instanceVariableNames:classVariableNames:poolDictionaries:category:;
		at: #words put: #variableWordSubclass:instanceVariableNames:classVariableNames:poolDictionaries:category:;
		at: #compiledMethod put: #subclass:instanceVariableNames:classVariableNames:poolDictionaries:category:;
		yourself.! !

!FLClassClusterSerializer methodsFor: 'private' stamp: 'MartinDias 3/18/2011 15:58'!
hackedClassPool: aClass

	self flag: #todo. "fix reifying better the graph iteration"
	^ aClass classPool isEmpty ifTrue: [ nil ] ifFalse: [ aClass classPool ]
	! !

!FLClassClusterSerializer methodsFor: 'private' stamp: 'MartinDias 3/20/2011 14:44'!
hackedSharedPools: aClass

	self flag: #todo. "fix reifying better the graph iteration"
	^ aClass sharedPools isEmpty ifTrue: [ nil ] ifFalse: [ aClass sharedPools ]
	! !

!FLClassClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 3/29/2011 22:42'!
materializeInstanceWith: aMaterializer

	| aClass superclass category name instanceVariableNames classSideInstanceVariableNames subclassSelector |
	superclass := aMaterializer nextReferencedObject.
	category := aMaterializer stream nextString.
	name := aMaterializer stream nextString asSymbol.
	instanceVariableNames := aMaterializer stream nextString.
	classSideInstanceVariableNames := aMaterializer stream nextString.
	subclassSelector := SubclassSelectors at: aMaterializer stream nextString asSymbol.

	aClass := superclass perform: subclassSelector withArguments: {name. instanceVariableNames. ''. ''. category}.
	aClass class instanceVariableNames: classSideInstanceVariableNames.
	^aClass! !

!FLClassClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/14/2011 21:48'!
materializeReferencesOf: aClass with: aMaterializer

	super materializeReferencesOf: aClass with: aMaterializer.

	aClass classPool: aMaterializer nextReferencedObject.
	aClass sharedPools: aMaterializer nextReferencedObject.
	aClass basicSubclasses: aMaterializer nextReferencedObject. 
	
	Class class instSize + 1 to: aClass class instSize 
		do: [ :index | aClass instVarAt: index put: aMaterializer nextReferencedObject ]! !

!FLClassClusterSerializer methodsFor: 'analyzing' stamp: 'MartinDias 5/14/2011 21:49'!
referencesOf: aClass do: aBlock

	super referencesOf: aClass do: aBlock.
	
	aBlock value: aClass superclass.
	aBlock value: (self hackedClassPool: aClass).
	aBlock value: (self hackedSharedPools: aClass). 
	aBlock value: aClass basicSubclasses. 

	Class class instSize + 1 to: aClass class instSize 
		do: [ :index | aBlock value: (aClass instVarAt: index) ]! !

!FLClassClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 5/12/2011 10:31'!
serializeInstance: aClass with: aSerializer

	aSerializer nextPutReferenceTo: aClass superclass.
	aSerializer stream nextStringPut: aClass basicCategory.
	aSerializer stream nextStringPut: aClass name.
	aSerializer stream nextStringPut: aClass instanceVariablesString.
	aSerializer stream nextStringPut: aClass class instanceVariablesString.
	aSerializer stream nextStringPut: aClass typeOfClass.! !

!FLClassClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/14/2011 21:51'!
serializeReferencesOf: aClass with: aSerializer

	super serializeReferencesOf: aClass with: aSerializer.

	aSerializer nextPutReferenceTo: (self hackedClassPool: aClass). 
	aSerializer nextPutReferenceTo: (self hackedSharedPools: aClass). 
	aSerializer nextPutReferenceTo:  aClass basicSubclasses.
 
	Class class instSize + 1 to: aClass class instSize 
		do: [ :index | aSerializer nextPutReferenceTo: (aClass instVarAt: index) ]! !

!FLClassOrTraitClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 3/29/2011 22:14'!
materializeInstanceWith: aMaterializer
	
	self explicitRequirement! !

!FLClassOrTraitClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 3/29/2011 23:47'!
materializePostReferencesOf: aClassOrTrait with: aMaterializer

	aClassOrTrait initializeTraitComposition: aMaterializer nextReferencedObject.
	aClassOrTrait classSide initializeTraitComposition: aMaterializer nextReferencedObject.! !

!FLClassOrTraitClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 3/29/2011 23:47'!
materializeReferencesOf: aClassOrTrait with: aMaterializer

	aClassOrTrait methodDictionary: aMaterializer nextReferencedObject.
	aClassOrTrait organization: aMaterializer nextReferencedObject.
	aClassOrTrait basicLocalSelectors: aMaterializer nextReferencedObject.
	
	aClassOrTrait classSide methodDictionary: aMaterializer nextReferencedObject.
	aClassOrTrait classSide organization: aMaterializer nextReferencedObject.
	aClassOrTrait classSide basicLocalSelectors: aMaterializer nextReferencedObject.! !

!FLClassOrTraitClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 3/29/2011 23:37'!
materializeWith: aMaterializer

	| classOrTrait |
	classOrTrait := self materializeInstanceWith: aMaterializer.
	
	aMaterializer referenceMaterializingActionsAdd: [ 
		self materializeReferencesOf: classOrTrait with: aMaterializer ].

	aMaterializer postReferenceMaterializingActionsAdd: [ 
		self materializePostReferencesOf: classOrTrait with: aMaterializer ].

	^classOrTrait! !

!FLClassOrTraitClusterSerializer methodsFor: 'analyzing' stamp: 'MartinDias 3/29/2011 23:48'!
referencesOf: aClassOrTrait do: aBlock

	aBlock value: aClassOrTrait methodDictionary.
	aBlock value: aClassOrTrait organization.
	aBlock value: aClassOrTrait traitComposition.
	aBlock value: aClassOrTrait basicLocalSelectors.
	
	aBlock value: aClassOrTrait classSide methodDictionary.
	aBlock value: aClassOrTrait classSide organization.
	aBlock value: aClassOrTrait classSide traitComposition.
	aBlock value: aClassOrTrait classSide basicLocalSelectors.! !

!FLClassOrTraitClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 3/29/2011 23:37'!
serialize: aClassOrTrait with: aSerializer

	self serializeInstance: aClassOrTrait with: aSerializer.

	aSerializer referenceSerializingActionsAdd:
		[ self serializeReferencesOf: aClassOrTrait with: aSerializer ].

	aSerializer postReferenceSerializingActionsAdd:
		[ self serializePostReferencesOf: aClassOrTrait with: aSerializer ].
! !

!FLClassOrTraitClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 3/29/2011 22:17'!
serializeInstance: aClassOrTrait with: aSerializer

	self explicitRequirement ! !

!FLClassOrTraitClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 3/29/2011 23:48'!
serializePostReferencesOf: aClassOrTrait with: aSerializer

	aSerializer nextPutReferenceTo: aClassOrTrait traitComposition.
	aSerializer nextPutReferenceTo: aClassOrTrait classSide traitComposition.
! !

!FLClassOrTraitClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 3/29/2011 23:48'!
serializeReferencesOf: aClassOrTrait with: aSerializer

	aSerializer nextPutReferenceTo: aClassOrTrait methodDictionary.
	aSerializer nextPutReferenceTo: aClassOrTrait organization. 
	aSerializer nextPutReferenceTo: aClassOrTrait basicLocalSelectors.
	
	aSerializer nextPutReferenceTo: aClassOrTrait classSide methodDictionary.
	aSerializer nextPutReferenceTo: aClassOrTrait classSide organization.
	aSerializer nextPutReferenceTo: aClassOrTrait classSide basicLocalSelectors.! !

FLClassOrTraitClusterSerializer subclass: #FLTraitClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLTraitClusterSerializer commentStamp: '<historical>' prior: 0!
I serialize a trait with full detail. The trait will be recreated completely on the materializing image.!

!FLTraitClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 3/24/2011 03:35'!
id
	^ 18! !

!FLTraitClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 3/29/2011 23:40'!
materializeInstanceWith: aMaterializer

	| category name |
	category := aMaterializer stream nextString.
	name := aMaterializer stream nextString asSymbol.
	^Trait named: name uses: {} category: category.! !

!FLTraitClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 5/12/2011 10:32'!
serializeInstance: aTrait with: aSerializer

	aSerializer stream nextStringPut: aTrait basicCategory.
	aSerializer stream nextStringPut: aTrait name.! !

FLIteratingClusterSerializer subclass: #FLClassPoolAssociationClusterSerializer
	instanceVariableNames: 'ownerClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLClassPoolAssociationClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for class variable associations, i.e. bindings that belong to the class pool of a Class included on Smalltalk globals.!

!FLClassPoolAssociationClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/18/2010 18:02'!
id

	^ 20! !

!FLClassPoolAssociationClusterSerializer classSide methodsFor: 'instance creation' stamp: 'MartinDias 10/18/2010 17:55'!
newFor: aClass

	^ self basicNew
		initialize;
		ownerClass: aClass;
		yourself.! !

!FLClassPoolAssociationClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 3/26/2011 17:04'!
materializeWith: aMaterializer

	| keyName |
	ownerClass := aMaterializer nextReferencedObject.
	keyName := aMaterializer stream nextString.
	^ ownerClass classPool associationAt: keyName asSymbol ! !

!FLClassPoolAssociationClusterSerializer methodsFor: 'accessing' stamp: 'MartinDias 10/18/2010 17:59'!
ownerClass: anObject
	ownerClass := anObject! !

!FLClassPoolAssociationClusterSerializer methodsFor: 'analyzing' stamp: 'MartinDias 11/11/2010 18:31'!
referencesOf: anAssociation do: aBlock

	aBlock value: ownerClass! !

!FLClassPoolAssociationClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 5/12/2011 10:32'!
serialize: anAssociation with: aSerializer

	aSerializer nextPutReferenceTo: ownerClass.
	aSerializer stream nextStringPut: anAssociation key! !

FLIteratingClusterSerializer subclass: #FLClassSideClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLClassSideClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for Metaclasses and ClassTrait.!

!FLClassSideClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:24'!
id
	^ 12! !

!FLClassSideClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 3/24/2011 12:27'!
materializeWith: aMaterializer

	^ aMaterializer nextReferencedObject classSide! !

!FLClassSideClusterSerializer methodsFor: 'analyzing' stamp: 'MartinDias 3/23/2011 18:06'!
referencesOf: aClassOrTraitClassSide do: aBlock

	aBlock value: aClassOrTraitClassSide instanceSide! !

!FLClassSideClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 3/24/2011 12:27'!
serialize: aClassOrTraitClassSide with: aSerializer

	aSerializer nextPutReferenceTo: aClassOrTraitClassSide instanceSide! !

FLIteratingClusterSerializer subclass: #FLCompiledMethodClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLCompiledMethodClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for CompiledMethod instances.!

!FLCompiledMethodClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:19'!
id
	^2! !

!FLCompiledMethodClusterSerializer methodsFor: 'protected' stamp: 'MartinDias 10/7/2010 00:36'!
materializeLiteralsTo: compiledMethod with: aMaterializer

	1 to: compiledMethod numLiterals 
		do: [ :index | compiledMethod literalAt: index put: aMaterializer nextReferencedObject ]
! !

!FLCompiledMethodClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/14/2011 19:46'!
materializeWith: aMaterializer

	| compiledMethod header bytecodesPlusTrailerSize aReadStream |

	aReadStream := aMaterializer stream.

	header := (aReadStream nextWord << 16) bitOr: aReadStream nextWord.
	bytecodesPlusTrailerSize := aReadStream nextWord.

	compiledMethod := CompiledMethod newMethod: bytecodesPlusTrailerSize header: header.

	compiledMethod initialPC to: compiledMethod size
		do: [ :index | compiledMethod at: index put: aReadStream next ].

	aMaterializer referenceMaterializingActionsAdd: 
		[ self materializeLiteralsTo: compiledMethod with: aMaterializer ].
		
	^ compiledMethod! !

!FLCompiledMethodClusterSerializer methodsFor: 'analyzing' stamp: 'MartinDias 3/26/2011 16:27'!
referencesOf: anObject do: aBlock

	1 to: anObject numLiterals
		do: [ :index | aBlock value: (anObject literalAt: index) ]! !

!FLCompiledMethodClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/14/2011 19:45'!
serialize: aCompiledMethod with: aSerializer

	| header aWriteStream bytecodesPlusTrailerSize cmSize cmInitialPC |

	aWriteStream := aSerializer stream.

	header := aCompiledMethod header.
	cmSize := aCompiledMethod size.
	cmInitialPC := aCompiledMethod initialPC.
	bytecodesPlusTrailerSize := cmSize - cmInitialPC + 1.

	aWriteStream 
		nextWordPut: (header >> 16);
		nextWordPut: header;
		nextWordPut: bytecodesPlusTrailerSize.

	cmInitialPC to: cmSize
		do: [ :index | aWriteStream nextPut: (aCompiledMethod at: index) ].

	aSerializer referenceSerializingActionsAdd: 
		[ self serializeLiteralsOf: aCompiledMethod with: aSerializer ]! !

!FLCompiledMethodClusterSerializer methodsFor: 'protected' stamp: 'MartinDias 10/7/2010 00:36'!
serializeLiteralsOf: aCompiledMethod with: aSerializer

	1 to: aCompiledMethod numLiterals 
		do: [ :index | aSerializer nextPutReferenceTo: (aCompiledMethod literalAt: index) ]! !

FLCompiledMethodClusterSerializer subclass: #FLNamedPrimitiveMethodClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLNamedPrimitiveMethodClusterSerializer commentStamp: 'MartinDias 11/2/2010 15:33' prior: 0!
I am a serializer for CompiledMethods which are <primitive:module:> primitives.

For example, Integer >> bitAnd: should be serialized with me.!

!FLNamedPrimitiveMethodClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/22/2010 12:08'!
id

	^ 23! !

!FLNamedPrimitiveMethodClusterSerializer methodsFor: 'protected' stamp: 'MartinDias 11/11/2010 18:33'!
materializeLiteralsTo: compiledMethod with: aMaterializer

	| module name |
	module := aMaterializer nextReferencedObject.
	name := aMaterializer nextReferencedObject.
	compiledMethod literalAt: 1 put: (Array with: module with: name with: 0 with: 0).

	2 to: compiledMethod numLiterals 
		do: [ :index | compiledMethod literalAt: index put: aMaterializer nextReferencedObject ]
! !

!FLNamedPrimitiveMethodClusterSerializer methodsFor: 'analyzing' stamp: 'MartinDias 11/11/2010 18:31'!
referencesOf: anObject do: aBlock

	aBlock 
		value: (anObject literalAt: 1) first;
		value: (anObject literalAt: 1) second. 

	2 to: anObject numLiterals
		do: [ :index | aBlock value: (anObject literalAt: index) ]! !

!FLNamedPrimitiveMethodClusterSerializer methodsFor: 'protected' stamp: 'MartinDias 10/26/2010 14:43'!
serializeLiteralsOf: aCompiledMethod with: aSerializer

	| primitiveArguments |
	
	primitiveArguments := aCompiledMethod literalAt: 1.
	aSerializer 
		nextPutReferenceTo: primitiveArguments first;
		nextPutReferenceTo: primitiveArguments second.

	2 to: aCompiledMethod numLiterals 
		do: [ :index | aSerializer nextPutReferenceTo: (aCompiledMethod literalAt: index) ]! !

!FLIteratingClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 13:27'!
materializeAllWith: aMaterializer
	"Template method that let to the subclass the materialization using the received materializer"

	| instanceCount |
	instanceCount := aMaterializer nextInteger.

	instanceCount timesRepeat: 
		[ aMaterializer addMaterialized: 
			(self materializeWith: aMaterializer) ].! !

!FLIteratingClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 13:30'!
materializeWith: aMaterializer
	"Hook method that each subclass should customize for its special way of materializing"

	^ self subclassResponsibility! !

!FLIteratingClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 11/11/2010 18:02'!
serialize: anObject with: aSerializer
	"Hook method that each subclass should customize for its special way of serializing"

	self subclassResponsibility ! !

!FLIteratingClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 13:27'!
serializeAll: aCollection with: aSerializer
	"Template method that let to the subclass the serialization of each instance received"

	aSerializer nextPutInteger: aCollection size.
	aCollection do: [ :instance | self serialize: instance with: aSerializer ]! !

FLIteratingClusterSerializer subclass: #FLMethodDictionaryClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLMethodDictionaryClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 3/22/2011 01:08'!
id
	^ 96! !

!FLMethodDictionaryClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 3/22/2011 02:11'!
materializeKeysAndValuesTo: aDictionary with: aMaterializer size: size
	
	size timesRepeat: [
		| method |
		method := aMaterializer nextReferencedObject.
		aDictionary at: method selector put: method ]! !

!FLMethodDictionaryClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/14/2011 19:46'!
materializeWith: aMaterializer
	
	| dictionary size |
	size := aMaterializer nextInteger.
	dictionary := MethodDictionary new: size.
	
	aMaterializer postReferenceMaterializingActionsAdd: [
		self materializeKeysAndValuesTo: dictionary with: aMaterializer size: size ].
	
	^ dictionary! !

!FLMethodDictionaryClusterSerializer methodsFor: 'analyzing' stamp: 'MartinDias 3/22/2011 02:06'!
referencesOf: aDictionary do: aBlock

	aDictionary do: [ :value | aBlock value: value ]! !

!FLMethodDictionaryClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/14/2011 19:46'!
serialize: aDictionary with: aSerializer

	aSerializer nextPutInteger: aDictionary size.
	aSerializer postReferenceSerializingActionsAdd: [
		self serializeKeysAndValuesOf: aDictionary with: aSerializer ]! !

!FLMethodDictionaryClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 3/24/2011 12:57'!
serializeKeysAndValuesOf: aDictionary with: aSerializer

	aDictionary do: [ :value | aSerializer nextPutReferenceTo: value ]! !

FLClusterSerializer subclass: #FLObjectClusterSerializer
	uses: FLTClassParameter
	instanceVariableNames: 'parameterClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLObjectClusterSerializer commentStamp: '<historical>' prior: 0!
I implement a generic way of serializing and materializing an object, for those that do not need more special way of doing it.

For example,

	10@20 fuelSerializer 

returns an instance of me.

!

FLObjectClusterSerializer class
	uses: FLTClassParameter classTrait
	instanceVariableNames: ''!

!FLObjectClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:24'!
id

	^0! !

!FLObjectClusterSerializer methodsFor: 'analyzing' stamp: 'MartinDias 4/19/2011 19:27'!
clusterReferencesDo: aBlock

	aBlock value: self parameterClass ! !

!FLObjectClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 5/12/2011 15:05'!
materializeAllWith: aMaterializer

	| instanceCount clusterInstances class instanceVariablesMapping numberOfInstanceVariables instanceVariableNames |

	self flag: #todo. "refactor this big method"

	class := aMaterializer nextReferencedObject.
	numberOfInstanceVariables := aMaterializer nextInteger.
	
	instanceVariableNames := (1 to: numberOfInstanceVariables) collect: [ :index | aMaterializer stream nextString ].
	instanceCount := aMaterializer nextInteger.
	clusterInstances := OrderedCollection new: instanceCount.

	instanceVariablesMapping := FLInstanceVariablesMapping 
			currentClass: class 
			originalInstanceVariableNames: instanceVariableNames.

	class isVariable
		ifTrue: [ 
			instanceCount timesRepeat: [ clusterInstances add: (class basicNew: aMaterializer nextInteger) ].
			aMaterializer referenceMaterializingActionsAdd: [ 
				self materializeVariableReferencesOfAll: clusterInstances with: aMaterializer ] ]
		ifFalse: [ 
			instanceCount timesRepeat: [ clusterInstances add: class basicNew ] ].

	class hasInstanceVariables
		ifTrue: [ 
			aMaterializer referenceMaterializingActionsAdd: [ 
				self 
					materializeReferencesOfAll: clusterInstances 
					with: aMaterializer 
					instanceVariablesMapping: instanceVariablesMapping ] ].
		
	aMaterializer addAllMaterialized: clusterInstances! !

!FLObjectClusterSerializer methodsFor: 'protected' stamp: 'MartinDias 11/12/2010 01:03'!
materializeReferencesOfAll: instances with: aMaterializer instanceVariablesMapping: instanceVariablesMapping
	
	instances
		do: [ :instance |
			instanceVariablesMapping materializeReferencesOf: instance with: aMaterializer ]! !

!FLObjectClusterSerializer methodsFor: 'protected' stamp: 'MartinDias 11/11/2010 18:14'!
materializeVariableReferencesOfAll: instances with: aMaterializer

	instances
		do: [ :instance |
			1 to: instance basicSize 
				do: [ :index | instance basicAt: index put: aMaterializer nextReferencedObject ]]! !

!FLObjectClusterSerializer methodsFor: 'accessing' stamp: 'MartinDias 4/19/2011 12:39'!
parameterClass

	^ parameterClass ! !

!FLObjectClusterSerializer methodsFor: 'accessing' stamp: 'MartinDias 4/19/2011 12:39'!
parameterClass: aClass

	parameterClass:= aClass ! !

!FLObjectClusterSerializer methodsFor: 'analyzing' stamp: 'MartinDias 4/19/2011 15:00'!
referencesOf: anObject do: aBlock

	anObject class isVariable 
		ifTrue: [ 
			1 to: anObject basicSize 
				do: [ :index | aBlock value: (anObject basicAt: index) ] ].
	
	1 to: anObject class instSize 
		do: [ :index | aBlock value: (anObject instVarAt: index) ]! !

!FLObjectClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 4/19/2011 12:39'!
serializeAll: clusterInstances with: aSerializer

	self serializeClassInfoWith: aSerializer.
	aSerializer nextPutInteger: clusterInstances size.

	parameterClass isVariable
		ifTrue: [ 
			clusterInstances do: [ :instance | aSerializer nextPutInteger: instance basicSize ].
			aSerializer referenceSerializingActionsAdd:
				[ self serializeVariableReferencesOfAll: clusterInstances with: aSerializer ] ].

	parameterClass hasInstanceVariables
		ifTrue: [ 
			aSerializer referenceSerializingActionsAdd:
				[ self serializeReferencesOfAll: clusterInstances with: aSerializer ] ]! !

!FLObjectClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 5/12/2011 15:07'!
serializeClassInfoWith: aSerializer

	aSerializer nextPutReferenceTo: parameterClass.
	aSerializer nextPutInteger: parameterClass instSize. 
	parameterClass instVarNamesAndOffsetsDo: [ :name :index | aSerializer stream nextStringPut: name ].
	
	self flag: #todo. "only 256 instance variables?"
! !

!FLObjectClusterSerializer methodsFor: 'protected' stamp: 'MartinDias 4/19/2011 12:39'!
serializeReferencesOfAll: instances with: aSerializer 
	
	instances 
		do: [ :anInstance |
			1 to: parameterClass instSize do: [ :index |
				aSerializer nextPutReferenceTo: (anInstance instVarAt: index) ]]
				
	! !

!FLObjectClusterSerializer methodsFor: 'protected' stamp: 'MartinDias 10/13/2010 11:14'!
serializeVariableReferencesOfAll: instances with: aSerializer

	instances 
		do: [ :anInstance |
			1 to: anInstance basicSize do: [ :index |
				aSerializer nextPutReferenceTo: (anInstance basicAt: index) ]]! !

FLClusterSerializer subclass: #FLPrimitiveClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLPrimitiveClusterSerializer commentStamp: '<historical>' prior: 0!
I am a template class whose algorithm for serialize a collection of objects is to delegate the serialization of each individual object to the subclass. 

(TODO) My main difference with FLIteratingClusterSerializer is that my method hooks only receive a stream and not the complete instance of FLSerializer, because they have not need. But possibly there is no reason for being different classes.!

FLPrimitiveClusterSerializer subclass: #FLByteArrayClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLByteArrayClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for ByteArray.!

!FLByteArrayClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/25/2010 14:37'!
id

	^25! !

!FLByteArrayClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 5/12/2011 10:38'!
materializeFrom: aReadStream

	^ aReadStream next: (aReadStream nextNumber: 4) ! !

!FLByteArrayClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 5/12/2011 10:39'!
serialize: aByteArray on: aWriteStream

	aWriteStream nextNumber: 4 put: aByteArray size.
	aWriteStream nextPutAll: aByteArray.
! !

FLPrimitiveClusterSerializer subclass: #FLByteStringClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLByteStringClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for ByteString.!

!FLByteStringClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/25/2010 13:32'!
id

	^24! !

!FLByteStringClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/25/2010 13:38'!
materializeFrom: aReadStream

	^ aReadStream nextString! !

!FLByteStringClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/25/2010 13:38'!
serialize: aString on: aWriteStream

	aWriteStream nextStringPut: aString! !

FLPrimitiveClusterSerializer subclass: #FLCharacterClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLCharacterClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for Character.!

!FLCharacterClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:24'!
id

	^1! !

!FLCharacterClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 11:06'!
materializeFrom: aReadStream

	^Character value: aReadStream next! !

!FLCharacterClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 11/22/2010 17:33'!
serialize: aCharacter on: aWriteStream

	aWriteStream nextPut: aCharacter codePoint! !

FLPrimitiveClusterSerializer subclass: #FLFloatClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLFloatClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for 8-byte Floats. 

Implementation took from ReferenceStream.
!

!FLFloatClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/20/2010 22:45'!
id
	^21! !

!FLFloatClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/21/2010 13:27'!
materializeFrom: aReadStream

	^ (Float new: 2)
		at: 1 put: (aReadStream nextNumber: 4);
		at: 2 put: (aReadStream nextNumber: 4);
		yourself.
! !

!FLFloatClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/21/2010 10:39'!
serialize: aFloat on: aWriteStream

	aWriteStream 
		nextNumber: 4 put: (aFloat at: 1);
		nextNumber: 4 put: (aFloat at: 2).! !

FLPrimitiveClusterSerializer subclass: #FLGlobalAssociationClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLGlobalAssociationClusterSerializer commentStamp: '<historical>' prior: 0!
I serialize variable bindings that belong to Smalltalk global dictionary.

For example, 

	Smalltalk globals associationAt: #Transcript 
	
could be serialized by me.!

!FLGlobalAssociationClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/18/2010 12:16'!
id
	^ 19! !

!FLGlobalAssociationClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/19/2010 15:08'!
materializeFrom: aReadStream

	^ Smalltalk globals 
		associationAt: aReadStream nextString asSymbol
		ifAbsent: [ self error: 'Association not found.' ] ! !

!FLGlobalAssociationClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/18/2010 12:10'!
serialize: anAssociation on: aWriteStream
	
	aWriteStream nextStringPut: anAssociation key! !

FLPrimitiveClusterSerializer subclass: #FLGlobalClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLGlobalClusterSerializer commentStamp: 'MartinDias 11/15/2010 11:16' prior: 0!
I am a serializer for known objects that belong to Smalltalk global dictionary.

For example, Transcript could be serialized by me.!

!FLGlobalClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:25'!
id
	^ 11! !

!FLGlobalClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/19/2010 14:52'!
materializeFrom: aReadStream

	^ Smalltalk globals 
		at: aReadStream nextString asSymbol 
		ifAbsent: [ self error: 'Smalltalk global not found' ]! !

!FLGlobalClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 5/12/2011 10:13'!
serialize: anObject on: aWriteStream
	
	aWriteStream 
		nextStringPut: (Smalltalk globals keyAtValue: anObject).! !

FLPrimitiveClusterSerializer subclass: #FLLargeNegativeIntegerClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLLargeNegativeIntegerClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for LargeNegativeInteger.!

!FLLargeNegativeIntegerClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:25'!
id
	^8! !

!FLLargeNegativeIntegerClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/12/2010 21:39'!
materializeFrom: aReadStream

	| size value |
	size := aReadStream next.
	value := 0.
	size timesRepeat: [value := (value bitShift: 8) bitOr: aReadStream next].
	^ value negated ! !

!FLLargeNegativeIntegerClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/12/2010 10:44'!
serialize: anInteger on: aWriteStream

	| size byte positive |
	positive := anInteger abs.
	size := (positive log: 256) floor + 1.
	aWriteStream nextPut:size.
	(size - 1 to: 0 by: -1) do:
		[:index |
			byte := (positive bitShift: index * -8) bitAnd: 255.
			aWriteStream nextPut: byte]! !

FLPrimitiveClusterSerializer subclass: #FLLargePositiveIntegerClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLLargePositiveIntegerClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for LargePositiveInteger.!

!FLLargePositiveIntegerClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:25'!
id
	^7! !

!FLLargePositiveIntegerClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/12/2010 21:39'!
materializeFrom: aReadStream

	| size value |
	size:=aReadStream next.
	value := 0.
	size timesRepeat: [value := (value bitShift: 8) bitOr: aReadStream next].
	^ value! !

!FLLargePositiveIntegerClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 9/27/2010 13:42'!
serialize: anInteger on: aWriteStream

	| size byte |
	size:=(anInteger log: 256) floor + 1.
	aWriteStream nextPut: size.
	(size - 1 to: 0 by: -1) do:
		[:index |
		byte := (anInteger bitShift: index * -8) bitAnd: 255.
		aWriteStream nextPut: byte]! !

FLPrimitiveClusterSerializer subclass: #FLNilTrueFalseClusterSerializer
	instanceVariableNames: ''
	classVariableNames: 'WellKnownObjectsDictionary'
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLNilTrueFalseClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for nil, true and false. They have a special treatment because they are so common in the image.!

!FLNilTrueFalseClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/19/2010 12:20'!
id

	^4! !

!FLNilTrueFalseClusterSerializer classSide methodsFor: 'class initialization' stamp: 'MartinDias 5/13/2011 10:24'!
initialize 

	WellKnownObjectsDictionary := Dictionary new
		add: 1 -> nil;
		add: 2 -> true;
		add: 3 -> false;
		yourself.! !

!FLNilTrueFalseClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/19/2010 12:21'!
materializeFrom: aReadStream
	
	^ WellKnownObjectsDictionary at: aReadStream next
	! !

!FLNilTrueFalseClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/19/2010 13:30'!
serialize: aWellKnownObject on: aWriteStream

	aWriteStream nextPut: (WellKnownObjectsDictionary keyAtValue: aWellKnownObject)! !

!FLPrimitiveClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 13:28'!
materializeAllWith: aMaterializer 
	"Template method that let to the subclass the materialization using the received materializer"
	
	| instanceCount |
	instanceCount := aMaterializer nextInteger.

	instanceCount timesRepeat: 
		[ aMaterializer addMaterialized: 
			(self materializeFrom: aMaterializer stream) ].! !

!FLPrimitiveClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 13:30'!
materializeFrom: aReadStream
	"Hook method that each subclass should customize for its special way of materializing"
	
	self subclassResponsibility ! !

!FLPrimitiveClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 13:29'!
serialize: anObject on: aWriteStream
	"Hook method that each subclass should customize for its special way of serializing"
	
	self subclassResponsibility! !

!FLPrimitiveClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 13:28'!
serializeAll: aCollection with: aSerializer
	"Template method that let to the subclass the serialization of each instance received"
	
	aSerializer nextPutInteger: aCollection size.
	aCollection do: [ :instance | self serialize: instance on: aSerializer stream ]! !

FLPrimitiveClusterSerializer subclass: #FLReferencedClassClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLReferencedClassClusterSerializer commentStamp: 'MartinDias 11/15/2010 11:20' prior: 0!
I am a serializer for classes that should be present when materializing. In other words, it only serializes a reference to the class, using its name.!

!FLReferencedClassClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 11/11/2010 21:01'!
id
	^ 81! !

!FLReferencedClassClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 3/19/2011 12:42'!
materializeFrom: aReadStream
	| className |
	className := aReadStream nextString asSymbol .
	^ Smalltalk globals 
		at: className
		ifAbsent: [ ClassNotFound new signal:  'Class', className, ' not found at materialization' ]! !

!FLReferencedClassClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 5/12/2011 10:32'!
serialize: aClass on: aWriteStream
	
	aWriteStream nextStringPut: aClass name ! !

FLPrimitiveClusterSerializer subclass: #FLSmallIntegerClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLSmallIntegerClusterSerializer commentStamp: '<historical>' prior: 0!
I don't have so much sense as a class, but I know which of my subclasses corresponds to each SmallInteger.!

FLSmallIntegerClusterSerializer subclass: #FLNegativeSmallIntegerClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLNegativeSmallIntegerClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for negative SmallInteger instances.!

!FLNegativeSmallIntegerClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:26'!
id
	^10! !

!FLNegativeSmallIntegerClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/12/2010 21:39'!
materializeFrom: aReadStream

	| hi mid1 mid2 lo |
	hi := aReadStream next.
	mid2 := aReadStream next.
	mid1 := aReadStream next.
	lo := aReadStream next.
	^ ((hi bitShift: 24) + (mid2 bitShift: 16) + (mid1 bitShift: 8) + lo) negated! !

!FLNegativeSmallIntegerClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/12/2010 10:38'!
serialize: anInteger on: aWriteStream

	| aPositiveInteger |
	aPositiveInteger := anInteger abs.
	aWriteStream nextPut: (aPositiveInteger bitShift: -24).
	aWriteStream nextPut: ((aPositiveInteger bitShift: -16) bitAnd: 255).
	aWriteStream nextPut: ((aPositiveInteger bitShift: -8) bitAnd: 255).
	aWriteStream nextPut: (aPositiveInteger bitAnd: 255).! !

FLSmallIntegerClusterSerializer subclass: #FLPositiveSmallIntegerClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLPositiveSmallIntegerClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for positive SmallInteger instances.!

!FLPositiveSmallIntegerClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:26'!
id
	^9! !

!FLPositiveSmallIntegerClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/15/2010 10:51'!
materializeFrom: aReadStream

	| hi mid1 mid2 lo |
	hi := aReadStream next.
	mid2 := aReadStream next.
	mid1 := aReadStream next.
	lo := aReadStream next.
	^ (((hi bitShift: 24) bitXor: (mid2 bitShift: 16)) bitXor: (mid1 bitShift: 8)) bitXor: lo! !

!FLPositiveSmallIntegerClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 9/24/2010 00:48'!
serialize: anInteger on: aWriteStream

	aWriteStream nextPut: (anInteger bitShift: -24).
	aWriteStream nextPut: ((anInteger bitShift: -16) bitAnd: 255).
	aWriteStream nextPut: ((anInteger bitShift: -8) bitAnd: 255).
	aWriteStream nextPut: (anInteger bitAnd: 255).! !

!FLSmallIntegerClusterSerializer classSide methodsFor: 'instance creation' stamp: 'MartinDias 12/28/2010 14:27'!
for: anSmallInteger
	"Returns the right subclass instance"

	((anSmallInteger bitAnd: 16rFFFF) = anSmallInteger)
		ifTrue: [ ^ FLUInt16ClusterSerializer instance ].

	anSmallInteger > 0 
		ifTrue: [ ^ FLPositiveSmallIntegerClusterSerializer instance ]
		ifFalse: [ ^ FLNegativeSmallIntegerClusterSerializer instance ]! !

FLSmallIntegerClusterSerializer subclass: #FLUInt16ClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLUInt16ClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for SmallInteger instances between 0 and 16rFFFF.!

!FLUInt16ClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 12/22/2010 12:21'!
id
	^90! !

!FLUInt16ClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/22/2010 12:20'!
materializeFrom: aReadStream

	| hi lo |
	hi := aReadStream next.
	lo := aReadStream next.
	^ (hi bitShift: 8) bitXor: lo! !

!FLUInt16ClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/22/2010 13:16'!
serialize: anInteger on: aWriteStream

	aWriteStream nextPut: (anInteger bitShift: -8).
	aWriteStream nextPut: (anInteger bitAnd: 255).! !

FLPrimitiveClusterSerializer subclass: #FLSymbolClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLSymbolClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for Symbol instances.!

!FLSymbolClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:26'!
id

	^3! !

!FLSymbolClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/26/2010 14:22'!
materializeFrom: aReadStream

	^ aReadStream nextString asSymbol! !

!FLSymbolClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 5/12/2011 10:13'!
serialize: aSymbol on: aWriteStream

	aWriteStream nextStringPut: aSymbol! !

FLClusterSerializer subclass: #FLRawArrayedCollectionClusterSerializer
	uses: FLTClassParameter
	instanceVariableNames: 'parameterClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLRawArrayedCollectionClusterSerializer commentStamp: 'MartinDias 4/19/2011 14:02' prior: 0!
I am a cluster serializer for ArrayedCollections subclasses that are raw bits and word-like. 

I use the ArrayedCollection messages #writeOn: and #newFromStream: for serialize and materialize instances.!

FLRawArrayedCollectionClusterSerializer class
	uses: FLTClassParameter classTrait
	instanceVariableNames: ''!

!FLRawArrayedCollectionClusterSerializer classSide methodsFor: 'instance creation' stamp: 'MartinDias 4/19/2011 12:47'!
id

	^ 60! !

!FLRawArrayedCollectionClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 4/19/2011 12:45'!
materializeAllWith: aMaterializer

	| arrayedCollectionClass numberOfCollections |
	arrayedCollectionClass := aMaterializer nextReferencedObject.
	numberOfCollections := aMaterializer nextInteger.
	numberOfCollections timesRepeat: [ 
		aMaterializer addMaterialized: (arrayedCollectionClass newFromStream: aMaterializer stream) ]! !

!FLRawArrayedCollectionClusterSerializer methodsFor: 'accessing' stamp: 'MartinDias 4/19/2011 12:49'!
parameterClass

	^ parameterClass! !

!FLRawArrayedCollectionClusterSerializer methodsFor: 'accessing' stamp: 'MartinDias 4/19/2011 12:49'!
parameterClass: aClass

	parameterClass := aClass ! !

!FLRawArrayedCollectionClusterSerializer methodsFor: 'analyzing' stamp: 'MartinDias 4/19/2011 15:02'!
referencesOf: anArrayedCollection do: aBlock
	"Evaluates the received block with each object referenced by anObject"
	
	aBlock value: self parameterClass  ! !

!FLRawArrayedCollectionClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 4/19/2011 12:44'!
serializeAll: arrayedCollections with: aSerializer

	aSerializer nextPutReferenceTo: self parameterClass.
	aSerializer nextPutInteger: arrayedCollections size.
	arrayedCollections do: [ :anArrayedCollection |
		anArrayedCollection writeOn: aSerializer stream ]! !

Object subclass: #FLInstanceVariablesMapping
	instanceVariableNames: 'mapping'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLInstanceVariablesMapping commentStamp: 'MartinDias 11/15/2010 11:40' prior: 0!
I am used to materialize instance variables in an object, tolerating "class shape changing".

Cases tolerated are:
- instance variable added
- instance variable order change
- instance variable removed

Note: This class may be refactorized, because it looks a bit weird.!

!FLInstanceVariablesMapping classSide methodsFor: 'instance creation' stamp: 'MartinDias 11/12/2010 00:58'!
currentClass: aClass originalInstanceVariableNames: originalInstanceVariableNames 
	
	^ self basicNew
		initializeWith: originalInstanceVariableNames and: aClass;
		yourself.! !

!FLInstanceVariablesMapping methodsFor: 'initialize-release' stamp: 'MartinDias 11/12/2010 00:58'!
initializeWith: originalInstanceVariableNames and: currentClass

	super initialize.
	
	mapping := originalInstanceVariableNames 
		collect: [ :name | currentClass instVarIndexFor: name ifAbsent: [ nil ] ].

! !

!FLInstanceVariablesMapping methodsFor: 'materialize' stamp: 'MartinDias 11/12/2010 01:17'!
materializeReferencesOf: anObject with: aMaterializer 

	1 to: mapping size 
		do: [ :index | 
			| referencedObject mappedIndex |
			
			referencedObject := aMaterializer nextReferencedObject.
			mappedIndex := mapping at: index.
			
			mappedIndex ifNotNil: [ 
					anObject 
						instVarAt: mappedIndex 
						put: referencedObject ] ].! !

Object subclass: #FLMaterializer
	instanceVariableNames: 'stream referenceMaterializingActions materializedInstances integerMaterializer materializedRoot clusterCount postReferenceMaterializingActions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core'!

!FLMaterializer commentStamp: '<historical>' prior: 0!
I am a binary object materializer. 

By sending me #materialize, I will recreate previously serialized objects by FLSerializer from a byte stream. The results are obtained sending #materializedRoots.

!

!FLMaterializer class methodsFor: 'creation' stamp: 'MartinDias 9/20/2010 20:34'!
on: aReadStream

	^self new
		stream: aReadStream; 
		yourself
! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MartinDias 10/13/2010 11:31'!
addAllMaterialized: aCollection
	
	materializedInstances addAll: aCollection ! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MartinDias 10/13/2010 11:24'!
addMaterialized: anObject
	
	materializedInstances add: anObject ! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 10/12/2010 16:12'!
clusterSerializerFor: id

	^ FLClusterSerializer forId: id.! !

!FLMaterializer methodsFor: 'initialize-release' stamp: 'MartinDias 3/20/2011 22:20'!
initialize 
	
	super initialize.
	referenceMaterializingActions := OrderedCollection new.
	postReferenceMaterializingActions := OrderedCollection new.! !

!FLMaterializer methodsFor: 'materializing' stamp: 'MartinDias 11/25/2010 19:14'!
materialize

	self materializeHeader.
	self materializeInstances.
	self materializeReferences.
	self materializeRoot.! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 11/25/2010 12:39'!
materializeCluster

	(self clusterSerializerFor: self nextSerializerId)
		materializeAllWith: self! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 2/26/2011 04:22'!
materializeHeader

	integerMaterializer := self clusterSerializerFor: self nextSerializerId.
	materializedInstances := OrderedCollection new: self nextInteger.
	clusterCount := self nextInteger.
! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 11/25/2010 19:16'!
materializeInstances

	clusterCount timesRepeat: [self materializeCluster].
! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 3/20/2011 22:20'!
materializeReferences

	referenceMaterializingActions
		do: [ :aBlock | aBlock value ].
	postReferenceMaterializingActions
		do: [ :aBlock | aBlock value ]
! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 10/28/2010 10:39'!
materializeRoot

	materializedRoot := self nextReferencedObject! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 10/12/2010 21:39'!
nextInteger
	^ integerMaterializer materializeFrom: stream! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 10/12/2010 21:39'!
nextReferencedObject 

	| referenceIndex |
	referenceIndex := integerMaterializer materializeFrom: stream.
	^ materializedInstances at: referenceIndex.! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 11/25/2010 12:38'!
nextSerializerId

	^ stream next! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MartinDias 3/20/2011 22:19'!
postReferenceMaterializingActionsAdd: aBlock
	"Adds an action for being valued at the references materializing step"
	
	postReferenceMaterializingActions add: aBlock ! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MartinDias 10/15/2010 10:47'!
referenceMaterializingActionsAdd: aBlock
	"Adds an action for being valued at the references materializing step"
	
	referenceMaterializingActions add: aBlock ! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MartinDias 10/28/2010 10:51'!
root

	^ materializedRoot ! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MartinDias 10/6/2010 19:50'!
stream
	^ stream! !

!FLMaterializer methodsFor: 'accessing' stamp: 'sd 9/8/2010 15:23'!
stream: aStream
	stream:= aStream.! !

Object subclass: #FLObjectAnalyzer
	instanceVariableNames: 'analyzer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Analyzer'!

!FLObjectAnalyzer commentStamp: '<historical>' prior: 0!
The purpose of my hierarchy is to collaborate with an Analyzer to traverse a graph of objects assigning to each of them an adequate FLClusterSerializer.!

FLObjectAnalyzer subclass: #FLClassPoolAssociationAnalyzer
	instanceVariableNames: 'notExternalObjects'
	classVariableNames: 'ClassPoolBindings'
	poolDictionaries: ''
	category: 'Fuel-Core-Analyzer'!

!FLClassPoolAssociationAnalyzer commentStamp: '<historical>' prior: 0!
I analyze variable class variable associations, i.e. bindings that belong to the class pool of a Class existent on Smalltalk globals. !

!FLClassPoolAssociationAnalyzer classSide methodsFor: 'class initialization' stamp: 'MartinDias 3/27/2011 06:55'!
classAdded: anEvent

	anEvent item classPool associationsDo: [ :aBinding | 
			ClassPoolBindings at: aBinding put: anEvent item ]


! !

!FLClassPoolAssociationAnalyzer classSide methodsFor: 'class initialization' stamp: 'MartinDias 3/27/2011 06:55'!
classModified: anEvent
	"Refresh bindings dictionary when the class variables are modified."

	anEvent item isBehavior ifFalse: [ ^self ].
	anEvent areClassVarsModified ifFalse: [ ^self ].
	anEvent oldItem classPool associationsDo: [ :aBinding | 
			ClassPoolBindings removeKey: aBinding ifAbsent: [] ].
	anEvent item classPool associationsDo: [ :aBinding | 
			ClassPoolBindings at: aBinding put: anEvent item ].
! !

!FLClassPoolAssociationAnalyzer classSide methodsFor: 'class initialization' stamp: 'MartinDias 3/27/2011 06:54'!
classRemoved: anEvent

	anEvent item classPool associationsDo: [ :association | 
		ClassPoolBindings
			removeKey: association
			ifAbsent: []]! !

!FLClassPoolAssociationAnalyzer classSide methodsFor: 'class initialization' stamp: 'MartinDias 5/13/2011 10:23'!
initialize

	self initializeClassPoolBindings.
	self initializeListeners.
! !

!FLClassPoolAssociationAnalyzer classSide methodsFor: 'class initialization' stamp: 'MartinDias 2/26/2011 03:07'!
initializeClassPoolBindings
	ClassPoolBindings := Dictionary new.
	Smalltalk allClassesAndTraitsDo: [ :aClass | 
		aClass classPool associationsDo: [ :aBinding | 
			ClassPoolBindings at: aBinding put: aClass ] ].
	ClassPoolBindings! !

!FLClassPoolAssociationAnalyzer classSide methodsFor: 'class initialization' stamp: 'MartinDias 3/26/2011 16:39'!
initializeListeners

	self flag: #todo. "also unregistrer? another better way of doing this?"

	SystemChangeNotifier uniqueInstance 
		notify: self
			ofSystemChangesOfItem: #class
			change: #Removed
			using: #classRemoved:;
		notify: self
			ofSystemChangesOfItem: #class
			change: #Added
			using: #classAdded:;
		notify: self
			ofSystemChangesOfItem: #class
			change: #Modified
			using: #classModified:! !

!FLClassPoolAssociationAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 3/27/2011 13:21'!
analyzes: anObject
	^ anObject isVariableBinding and: [ (self isClassVariableBinding: anObject) and: [ self isExternal: anObject ] ]! !

!FLClassPoolAssociationAnalyzer methodsFor: 'initialize-release' stamp: 'MartinDias 3/26/2011 17:15'!
initialize

	super initialize.
	notExternalObjects := OrderedCollection new.! !

!FLClassPoolAssociationAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 3/27/2011 13:21'!
isClassVariableBinding: anObject
	^ ClassPoolBindings includesKey: anObject! !

!FLClassPoolAssociationAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 3/27/2011 13:20'!
isExternal: anObject
	^ (notExternalObjects includes: (ClassPoolBindings at: anObject)) not! !

!FLClassPoolAssociationAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 3/26/2011 17:14'!
notExternalObjects
	^ notExternalObjects! !

!FLClassPoolAssociationAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 3/26/2011 17:14'!
notExternalObjects: anObject
	notExternalObjects := anObject! !

!FLClassPoolAssociationAnalyzer methodsFor: 'evaluating' stamp: 'MarianoMartinezPeck 12/2/2010 15:43'!
value: anObject

	| ownerClass |
	ownerClass  := ClassPoolBindings at: anObject.
	
	analyzer 
		clusters: analyzer clusteredBaselevelObjects
		add: anObject  
		serializer: (FLClassPoolAssociationClusterSerializer newFor: ownerClass)! !

FLObjectAnalyzer subclass: #FLDefaultAnalyzer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Analyzer'!

!FLDefaultAnalyzer commentStamp: '<historical>' prior: 0!
I analyze objects using the serializer specified by each's #fuelSerializer message. 

I use the visitor pattern because I'm quite coupled to each serializer implementation. (TODO) Maybe this design must be changed.

Any object could be analyzed by me.!

!FLDefaultAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 10/26/2010 10:24'!
analyzes: anObject

	^ true! !

!FLDefaultAnalyzer methodsFor: 'visiting' stamp: 'MartinDias 3/17/2011 16:43'!
classAndTraitCollection
	"Returns the proper collection for collecting classes and traits"

	self flag: #todo. "slow"
	^ SortedCollection sortBlock: [ :a :b | a printCompactHierarchy <= b printCompactHierarchy ]! !

!FLDefaultAnalyzer methodsFor: 'evaluating' stamp: 'MartinDias 10/20/2010 15:40'!
value: anObject

	anObject fuelAccept: self! !

!FLDefaultAnalyzer methodsFor: 'visiting' stamp: 'MartinDias 3/17/2011 16:38'!
visitClassOrTrait: aClassOrTrait
	"Visits a Class or a Trait that should be fully serialized."

	analyzer
		clusters: analyzer clusteredInternalMetalevelObjects
		add: aClassOrTrait
		serializer: aClassOrTrait fuelSerializer
		collectionFactoryBlock: [ self classAndTraitCollection ]! !

!FLDefaultAnalyzer methodsFor: 'visiting' stamp: 'MartinDias 11/12/2010 16:10'!
visitMetaclass: aMetaclass

	analyzer  
		clusters: analyzer clusteredBaselevelObjects 
		add: aMetaclass! !

!FLDefaultAnalyzer methodsFor: 'visiting' stamp: 'MartinDias 11/11/2010 16:12'!
visitNilTrueFalse: anObject
	"Visits these singleton objects. They has a special treatment because they are so common. And also nil is special because it cannot be added to a Set like the other objects."

	analyzer 
		clusters: analyzer clusteredBaselevelObjects 
		add: anObject 
		serializer: anObject fuelSerializer 
		collectionFactoryBlock: [ OrderedCollection new ]! !

!FLDefaultAnalyzer methodsFor: 'visiting' stamp: 'MartinDias 11/11/2010 16:11'!
visitObject: anObject
	"Visits an object in the most generic way"

	analyzer
		clusters: analyzer clusteredBaselevelObjects
		add: anObject! !

!FLDefaultAnalyzer methodsFor: 'visiting' stamp: 'MartinDias 11/11/2010 14:22'!
visitPrimitive: anObject
	"Visits the objects who do not depend on others"

	analyzer 
		clusters: analyzer clusteredBaselevelObjects 
		add: anObject! !

FLObjectAnalyzer subclass: #FLGlobalAnalyzer
	instanceVariableNames: 'notExternalObjects'
	classVariableNames: 'GlobalObjects'
	poolDictionaries: ''
	category: 'Fuel-Core-Analyzer'!

!FLGlobalAnalyzer commentStamp: '<historical>' prior: 0!
I analyze classes and well known objects that belong to Smalltalk global dictionary.

For example, Transcript is analyzed by me.!

!FLGlobalAnalyzer classSide methodsFor: 'class initialization' stamp: 'MarianoMartinezPeck 12/2/2010 15:44'!
classAdded: anEvent

	GlobalObjects add: anEvent item

! !

!FLGlobalAnalyzer classSide methodsFor: 'class initialization' stamp: 'MarianoMartinezPeck 12/2/2010 15:31'!
classRemoved: anEvent

	GlobalObjects 
		remove: anEvent item
		ifAbsent: [ ]! !

!FLGlobalAnalyzer classSide methodsFor: 'accessing' stamp: 'MartinDias 11/25/2010 16:16'!
globalNames

	^ #(#Display #World #Smalltalk #Transcript #SourceFiles #Processor #ImageImports #TextConstants #Undeclared #SystemOrganization #Sensor #ActiveWorld)! !

!FLGlobalAnalyzer classSide methodsFor: 'accessing' stamp: 'MartinDias 11/25/2010 16:00'!
globalObjects

	^ GlobalObjects! !

!FLGlobalAnalyzer classSide methodsFor: 'class initialization' stamp: 'MartinDias 11/25/2010 16:17'!
initialize

	super initialize.
	self initializeGlobalObjects.
	self initializeListeners.
! !

!FLGlobalAnalyzer classSide methodsFor: 'class initialization' stamp: 'MartinDias 11/25/2010 16:16'!
initializeGlobalObjects

	GlobalObjects := (Smalltalk allClassesAndTraits asIdentitySet)
		addAll: (self globalNames collect: [ :key | Smalltalk globals at: key ]);
		yourself! !

!FLGlobalAnalyzer classSide methodsFor: 'class initialization' stamp: 'MartinDias 11/25/2010 16:30'!
initializeListeners

	self flag: #todo. "unregistrer? anocher better way of doing this?"

	SystemChangeNotifier uniqueInstance 
		notify: self
			ofSystemChangesOfItem: #class
			change: #Removed
			using: #classRemoved:;
		notify: self
			ofSystemChangesOfItem: #class
			change: #Added
			using: #classAdded:! !

!FLGlobalAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 3/2/2011 20:39'!
analyzes: anObject

	^ (self class globalObjects includes: anObject) and: [(notExternalObjects includes: anObject) not]! !

!FLGlobalAnalyzer methodsFor: 'initialize-release' stamp: 'MartinDias 5/13/2011 10:24'!
initialize

	notExternalObjects := OrderedCollection new.! !

!FLGlobalAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 3/2/2011 20:39'!
notExternalObjects
	^ notExternalObjects! !

!FLGlobalAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 3/2/2011 20:39'!
notExternalObjects: anObject
	notExternalObjects := anObject! !

!FLGlobalAnalyzer methodsFor: 'evaluating' stamp: 'MartinDias 10/20/2010 15:40'!
value: anObject

	anObject fuelAccept: self! !

!FLGlobalAnalyzer methodsFor: 'visiting' stamp: 'MartinDias 3/2/2011 23:56'!
visitClassOrTrait: aClassOrTrait

	analyzer  
		clusters: analyzer clusteredExternalMetalevelObjects 
		add: aClassOrTrait 
		serializer: FLReferencedClassClusterSerializer instance! !

!FLGlobalAnalyzer methodsFor: 'visiting' stamp: 'MartinDias 3/2/2011 23:56'!
visitObject: anObject

	analyzer 
		clusters: analyzer clusteredExternalMetalevelObjects
		add: anObject  
		serializer: FLGlobalClusterSerializer instance! !

FLObjectAnalyzer subclass: #FLGlobalAssociationAnalyzer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Analyzer'!

!FLGlobalAssociationAnalyzer commentStamp: '<historical>' prior: 0!
I analyze variable bindings that belong to Smalltalk global dictionary.

For example, 

	Smalltalk globals associationAt: #Transcript 
	
is analyzed by me.!

!FLGlobalAssociationAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 10/26/2010 10:24'!
analyzes: anObject

	^ anObject isVariableBinding and: [Smalltalk globals includesAssociation: anObject ].
! !

!FLGlobalAssociationAnalyzer methodsFor: 'evaluating' stamp: 'MartinDias 3/18/2011 11:57'!
value: anObject

	analyzer 
		clusters: analyzer clusteredBaselevelObjects
		add: anObject  
		serializer: FLGlobalAssociationClusterSerializer instance! !

!FLObjectAnalyzer classSide methodsFor: 'instance creation' stamp: 'MartinDias 10/20/2010 15:46'!
newWith: anAnalyzer

	^ self basicNew
		initialize;
		analyzer: anAnalyzer;
		yourself! !

!FLObjectAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 10/20/2010 15:42'!
analyzer
	^ analyzer! !

!FLObjectAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 10/20/2010 15:42'!
analyzer: anObject
	analyzer := anObject! !

!FLObjectAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 10/26/2010 10:23'!
analyzes: anObject
	"Tells if the received object is handled by this analyzer"

	self subclassResponsibility ! !

!FLObjectAnalyzer methodsFor: 'evaluating' stamp: 'MartinDias 10/25/2010 15:20'!
value: anObject
	"Executes the analysis on the object received."

	self subclassResponsibility ! !

Object subclass: #FLSerializer
	instanceVariableNames: 'stream instanceIndexes referenceSerializingActions integerSerializer postReferenceSerializingActions originalStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core'!

!FLSerializer commentStamp: '<historical>' prior: 0!
I am a binary object serializer. 

By sending me #serializeAll: with a collection of objects as argument, I will write them on a byte stream, such that later a FLMaterializer instance will be able to read the stream and recreate the objects in the same or another image.!

!FLSerializer class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 5/12/2011 11:08'!
on: aWriteStream

	self flag: #todo "this 100 should be a setting".
	^ self on: aWriteStream hintSize: 100 ! !

!FLSerializer class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 5/12/2011 11:07'!
on: aWriteStream hintSize: aNumber 
	
	^ self new
		initializeWith: aWriteStream hintSize: aNumber.
	! !

!FLSerializer methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 5/17/2011 23:33'!
initializeWith: aWriteStream hintSize: aNumber.

	"Usually, pre-allocating a collection is faster than make it grow. So we can have a default initial value"
	instanceIndexes := IdentityDictionary new: aNumber.
	referenceSerializingActions := OrderedCollection new.
	postReferenceSerializingActions := OrderedCollection new.
	originalStream := aWriteStream.
	self flag: #todo. "when the settings is ready, we can direcly set to 'stream' the original one instead of this buffer'  "
"	stream := ByteArray new writeStream."
	stream := FLBufferedWriteStream on: originalStream! !

!FLSerializer methodsFor: 'accessing' stamp: 'MartinDias 9/27/2010 14:53'!
nextPutInteger: anInteger

	integerSerializer serialize: anInteger on: stream! !

!FLSerializer methodsFor: 'accessing' stamp: 'MartinDias 9/27/2010 14:52'!
nextPutReferenceTo: anObject

	integerSerializer serialize: (instanceIndexes at: anObject) on: stream! !

!FLSerializer methodsFor: 'private' stamp: 'MartinDias 11/25/2010 12:34'!
nextPutSerializerId: id

	stream nextPut: id! !

!FLSerializer methodsFor: 'accessing' stamp: 'MartinDias 3/20/2011 22:19'!
postReferenceSerializingActionsAdd: aBlock
	"Adds an action for being valued at the references serializing step"
	
	postReferenceSerializingActions add: aBlock ! !

!FLSerializer methodsFor: 'accessing' stamp: 'MartinDias 10/15/2010 10:47'!
referenceSerializingActionsAdd: aBlock
	"Adds an action for being valued at the references serializing step"
	
	referenceSerializingActions add: aBlock ! !

!FLSerializer methodsFor: 'serializing' stamp: 'MartinDias 11/3/2010 15:28'!
serialize: anObject 
	"Serializes using the default analyzer"

	self serialize: anObject analyzer: FLAnalyzer newDefault! !

!FLSerializer methodsFor: 'serializing' stamp: 'MarianoMartinezPeck 5/17/2011 23:35'!
serialize: anObject analyzer: anAnalyzer
	"Main message for serializing"

	| objectCount clusteredObjects |
	anAnalyzer analyze: anObject.

	clusteredObjects := anAnalyzer clusteredObjects.
	objectCount := anAnalyzer objectCount.
	integerSerializer := objectCount fuelSerializer.

	self serializeHeaderWith: clusteredObjects and: objectCount.
	self serializeInstances: clusteredObjects.
	self serializeReferences.
	self serializeRoot: anObject.

	stream flush.
	stream close.
	self flag: #fix.  "this is an ugly hack beause benchmarks and test are wrong and reuses the same stream for serializing and maerializing"
	stream := originalStream.
	! !

!FLSerializer methodsFor: 'private' stamp: 'MartinDias 2/26/2011 04:23'!
serializeHeaderWith: clusteredObjects and: objectCount

	self nextPutSerializerId: integerSerializer class id.
	self nextPutInteger: objectCount.
	self nextPutInteger: clusteredObjects size! !

!FLSerializer methodsFor: 'private' stamp: 'MartinDias 3/21/2011 01:08'!
serializeInstances: clusteredInstances

	clusteredInstances
		do: [ :anAssociation | 
			| serializer instances |
			serializer := anAssociation key.
			instances := anAssociation value.

			instances do: [ :instance | instanceIndexes at: instance put: instanceIndexes size + 1 ].
			self nextPutSerializerId: serializer class id.
			serializer serializeAll: instances with: self.
		]! !

!FLSerializer methodsFor: 'private' stamp: 'MartinDias 3/20/2011 22:19'!
serializeReferences

	referenceSerializingActions 
		do: [ :aBlock | aBlock value ].
	postReferenceSerializingActions 
		do: [ :aBlock | aBlock value ]! !

!FLSerializer methodsFor: 'private' stamp: 'MartinDias 10/28/2010 10:36'!
serializeRoot: anObject

	self nextPutReferenceTo: anObject! !

!FLSerializer methodsFor: 'accessing' stamp: 'sd 9/8/2010 14:59'!
stream
	^ stream! !

Object subclass: #FLSimpleStack
	instanceVariableNames: 'array slotIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Collections'!

!FLSimpleStack class methodsFor: 'instance creation' stamp: 'MartinDias 5/15/2011 23:11'!
hintSize

	^64! !

!FLSimpleStack class methodsFor: 'instance creation' stamp: 'MartinDias 5/15/2011 23:11'!
new
	
	^ self new: self hintSize! !

!FLSimpleStack class methodsFor: 'instance creation' stamp: 'MartinDias 5/15/2011 23:09'!
new: nElements
	"Create a Set large enough to hold nElements without growing"
	^ self basicNew initialize: nElements! !

!FLSimpleStack methodsFor: 'accessing' stamp: 'MartinDias 5/15/2011 23:08'!
capacity

	^ array size! !

!FLSimpleStack methodsFor: 'adding' stamp: 'MartinDias 5/15/2011 23:15'!
grow
	"Become larger in capacity."
	| newArray |
	newArray := Array new: array size * 2.
	newArray replaceFrom: 1 to: array size with: array startingAt: 1.
	array := newArray! !

!FLSimpleStack methodsFor: 'initialize-release' stamp: 'MartinDias 5/15/2011 23:10'!
initialize: hintSize

	array := Array new: hintSize.
	slotIndex := 1.! !

!FLSimpleStack methodsFor: 'accessing' stamp: 'MartinDias 5/15/2011 22:54'!
isEmpty

	^ 1 = slotIndex! !

!FLSimpleStack methodsFor: 'removing' stamp: 'MartinDias 5/15/2011 22:52'!
pop
	"Returns the first element and remove it from the stack."

	slotIndex := slotIndex - 1.	
	^ array at: slotIndex ! !

!FLSimpleStack methodsFor: 'adding' stamp: 'MartinDias 5/15/2011 22:44'!
push: anObject 
	"Adds a new object of any kind on top of the stack."

	array at: slotIndex put: anObject.
	array size = slotIndex ifTrue: [ self grow ].
	slotIndex := slotIndex + 1.
	^ anObject.! !

!Object methodsFor: '*Fuel' stamp: 'MartinDias 9/27/2010 16:49'!
fuelAccept: aVisitor

	aVisitor visitObject: self.
! !

!Object methodsFor: '*Fuel' stamp: 'MartinDias 9/24/2010 01:36'!
fuelSerializer

	^ FLObjectClusterSerializer for: self class! !
FLClassClusterSerializer initialize!
FLClassPoolAssociationAnalyzer initialize!
FLClusterSerializer initialize!
FLGlobalAnalyzer initialize!
FLNilTrueFalseClusterSerializer initialize!
